// Dave Waters, 25.06.2001
// =======================
// Driver macro :
// --------------
// (i)   Load the necessary shared libraries.
// (ii)  Compile the analysis code into a shared library.
// (iii) Run the analysis code.
//
// Note that running in compiled mode is much faster than running 
// in interpreter mode.
//
{
  // Load the Phyics library, containing for example TLorentzVector :
  // ================================================================
  gSystem->Load("$ROOTSYS/lib/libPhysics.so");

  // Compile the analysis code into a shared library. This also loads
  // the resulting shared library :
  // ================================================================
  // (Uncomment this to see the compile/link lines in full)
  // cout << gSystem->GetMakeSharedLib() << endl;
  gSystem->CompileMacro("ntuple_analysis.cc","-v");

  // Run the analysis job :
  // ======================
  ntuple_analysis();

}


