
      subroutine mcfm_cdf_init()
c     ------------------------------------------------------------------
c        1         2         3         4         5         6         7
      implicit none

#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/npart.F"
#include "mcfm/../src/Inc/mxdim.F"
#include "mcfm/../src/Inc/efficiency.F"
#include "mcfm/../src/Inc/maxwt.F"
#include "mcfm/../src/Inc/eventbuffer.F"

      logical verbose,creatent,dswhisto
      double precision taumin,rtsmin,sqrts,p1ext(4),p2ext(4),
     .     vector(mxdim),p(mxpart,4),s(mxpart,mxpart),val
      common/outputflags/creatent,dswhisto
      common/verbose/verbose
      common/taumin/taumin
      common/rtsmin/rtsmin
      common/energy/sqrts
      common/pext/p1ext,p2ext
      data p/mxpart*0d0,mxpart*0d0,mxpart*0d0,mxpart*0d0/
      data vector/mxdim*0d0/

* Welcome banner
      call banner
* Read-in the options.DAT file
      call reader

* For CDF, set this to true to avoid all other histogram 
* booking. Almost certainly want to skip though (see next
* flag) :
      creatent = .true.

* For CDF, don't do any private ntupling :
      skipnt = .true.

* Shouldn't matter if creatent is true above :
      dswhisto=.false.

* We are running in event generation mode for CDF :
      evtgen =   .true.

* Initialize efficiency variables      
      njetzero=0
      ncutzero=0
      ntotzero=0
      ntotshot=0
      
      if (verbose) then
      write(6,*)
      write(6,*) '****************************************'
      write(6,*) '*     Cross section in femtobarns      *'
      write(6,*) '****************************************'
      write(6,*)
      endif

* Set-up incoming beams
      
      taumin=(rtsmin/sqrts)**2

      p1ext(4)=-half*sqrts
      p1ext(1)=0d0
      p1ext(2)=0d0
      p1ext(3)=-half*sqrts

      p2ext(4)=-half*sqrts
      p2ext(1)=0d0
      p2ext(2)=0d0
      p2ext(3)=+half*sqrts

* Initialize all histograms
* npart=6 is a dummy value, to ensure that all histograms are included
      npart=6
      call dotem(8,p,s)
      val=0d0   
      call nplotter(vector,s,p,val,1)
           
      return
      end
c

      subroutine mcfm_cdf_vegas_prepare()
      
      implicit none
      
#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/maxwt.F"
#include "mcfm/../src/Inc/eventbuffer.F"
      
      integer itmx1,ncall1,itmx2,ncall2,icall
      double precision integ,integ_err
      logical dryrun
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/intres/integ,integ_err
      common/dryrun/dryrun
      external vegas_mcfm,vegas1_mcfm,vegas2_mcfm,vegas3_mcfm

      write(6,*) 'mcfm_cdf_vegas_prepare ...'

      dryrun = .false.
      call mcfm_vegas(vegas_mcfm,itmx1,ncall1,dryrun,integ,integ_err)
      wtmax = 0.0
      if (dryrun .eqv. .false.) then
        call mcfm_vegas(vegas1_mcfm,itmx2,ncall2,.true.,integ,integ_err)
      endif
      
      numstored = 0.0

      return
      end
c

      subroutine mcfm_cdf_getevent()
      implicit none

#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/maxwt.F"
#include "mcfm/../src/Inc/eventbuffer.F"

      double precision p(mxpart,4)
      double precision wt      
      integer pflav,pbarflav
      common /cdfevent/p,wt,pflav,pbarflav

c --- Get the event, keeping the 4-momenta in 
c --- a common block rather than returning :
      call mcfm_getevent(p,wt,pflav,pbarflav)

      end
c

      subroutine mcfm_cdf_stdhep()
      implicit none

#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/maxwt.F"
#include "mcfm/../src/Inc/eventbuffer.F"

      double precision p(mxpart,4)
      double precision wt 
      integer pflav,pbarflav
      common /cdfevent/p,wt,pflav,pbarflav

c --- Fill STDHEP common block based on the
c --- 4-momenta stored in mcfm_cdf_getevent above :
      call fill_stdhep(p,0,0,wt)
c     call write_stdhep(6)

      end
c

      subroutine mcfm_cdf_exit()

      implicit none

      integer itmx1,ncall1,itmx2,ncall2,icall
      double precision integ,integ_err
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/intres/integ,integ_err

      call mcfm_exit(integ,integ_err)

      return
      end


