      program main

c ======================================================================
c  Dave Waters, 29.5.2001
c  ----------------------
c  A program to merge histograms generated by the Monte Carlo program
c  MCFM. When calculating NLO cross sections the real and virtual 
c  pieces can be separately calculated and combined to give the final
c  distribution.
c
c ======================================================================
c        1         2         3         4         5         6         7

      implicit none

      integer NWPAWC
      parameter(NWPAWC=10000000)
      real         HMEMOR(NWPAWC)
      common/PAWC/ HMEMOR

      integer ISTAT,iErr
      character*100 outfile

c ----------------------------------------------------------------------
c     Define the output file name :
      outfile='mcfm_merged.rz'
c ----------------------------------------------------------------------

      call hlimit(NWPAWC)

c     Open the file that will contain all the output histograms :
c     call hropen(35,'HISTOS',outfile,'N',1024,ISTAT)
c     if (ISTAT.NE.0) then
c       write(6,*) 'ERROR ReadInOut : hropen (HISTOS), ISTAT =',
c    +                                                 ISTAT
c       stop
c     endif

       call histomerge

c     call hrend('HISTOS')
c     close(35)

      end

c

      subroutine histomerge
c ======================================================================
c
c ======================================================================
c        1         2         3         4         5         6         7
      implicit none

c     integer NWPAWC
c     parameter(NWPAWC=10000000)
c     real         HMEMOR(NWPAWC)
c     common/PAWC/ HMEMOR

c     integer ISTAT,ICYCLE,ihisto,intuple,idnext,i,ierror
      character*100 infile(2)
c     character*100 htype,htitle
c     integer nvar,nevents
c     character*10 chtags(512)
c     real var(512),rlow(512),rhigh(512)

c     integer nx,ny,nw,loc
c     real xmin,xmax,ymin,ymax
c     real histocontents1(5000),
c    +     histocontents2(5000),
c    +     histocontentssum(5000)

c ----------------------------------------------------------------------
c     Define the input file names :
      infile(1)='real/mcfm.rz'
      infile(2)='virt/mcfm.rz'
c ----------------------------------------------------------------------

      call hmerge(2,infile,'mcfm_merged.rz')

c --- The long and painful way of doing it. This migt still be useful
c --- in certain cases. For example, one might want to combined 
c --- histograms of errors in quadrature rather than linearly, as will
c --- be the case calling "hmerge".
c --- ==================================================================
c --- Open the input histogram files :
c     call hropen(30,'IN1',infile(1),' ',1024,ISTAT)
c     if (ISTAT.NE.0) then
c       write(6,*) 'hbook_merger : ERROR reading file. ISTAT = ',
c    +        ISTAT
c       stop
c     endif
c     call hropen(31,'IN2',infile(2),' ',1024,ISTAT)
c     if (ISTAT.NE.0) then
c       write(6,*) 'hbook_merger : ERROR reading file. ISTAT = ',
c    +        ISTAT
c       stop
c     endif
c
c     idnext=0
c     
c     do ihisto=1,1000
c
c       call hcdir('//IN1',' ')
c
c ---   Get the details of the next histogram in this file :
c       call hlnext(idnext,htype,htitle,'1')
c       if (idnext.EQ.0) goto 2001
c
c       write(6,*) 'Histogram found with ID = ',idnext
c       call hrin(idnext,999999,0)
c       call hgive(idnext,htitle,nx,xmin,xmax,ny,ymin,ymax,nw,loc)
c       write(6,*) 'nchannels=',nx,'xmin=',xmin,'xmax=',xmax
c
c ---   Grab the contents of the histogram :
c       call hunpak(idnext,histocontents1,' ',1)
c
c ---   Get the corresponding histogram from the second file :
c       call hdelet(idnext)
c       call hcdir('//IN2',' ')
c       call hrin(idnext,999999,0)
c       call hunpak(idnext,histocontents2,' ',1)
c       call hdelet(idnext)
c
c ---   Book and fill the sum histogram :
c       call hcdir('//HISTOS',' ')
c       call hbook1(idnext,htitle,nx,xmin,xmax,0.)
c ---   For the cross sections always add, for the errors add in
c ---   quadrature :
c       if (idnext.NE.200) then
c         do i=1,nx
c           histocontentssum(i)=histocontents1(i)+histocontents2(i)
c         enddo
c       else
c         histocontentssum(1)=histocontents1(1)+histocontents2(1)
c         histocontentssum(2)=sqrt( histocontents1(2)**2 + 
c    +                              histocontents2(2)**2 )
c         write(6,90) 
c         write(6,91) histocontents1(1),histocontents1(2)
c         write(6,92) histocontents2(1),histocontents2(2)
c         write(6,94)
c         write(6,93) histocontentssum(1),histocontentssum(2)
c         write(6,90)
c90       format('******************************************************
c    +**********')
c91       format('* Real    cross section = ',F14.7,' +/- ',F14.7,
c    +' fb *')
c92       format('* Virtual cross section = ',F14.7,' +/- ',F14.7,
c    +' fb *')
c93       format('* Total   cross section = ',F14.7,' +/- ',F14.7,
c    +' fb *')
c94       format('* ----------------------------------------------------
c    +-------- *')
c       endif
c       do i=1,nx
c         write(6,*) 'i : 1,2,sum = ',i,' : ',histocontents1(i),' ',
c    +                                        histocontents2(i),' ',
c    +                                        histocontentssum(i)
c       enddo
c
c       call hpak(idnext,histocontentssum)
c       call hrout(idnext,ICYCLE,' ')
c       if (ICYCLE.NE.1) then
c         write(6,*) 'ReadInOut : ICYCLE =',ICYCLE
c         write(6,*) 'Dupicated HISTO ID'
c       endif        
c
c     enddo
c
c2001 continue  
c
c --- Do the same for any ntuples present :
c     do intuple=1,1000
c
c       call hcdir('//IN1',' ')
c
c ---   Get the details of the next ntuple in this file :
c       call hlnext(idnext,htype,htitle,'N')
c       if (idnext.EQ.0) goto 2002
c       write(6,*) 'Ntuple found with ID = ',idnext
c       call hrin(idnext,999999,0)
c       call hnoent(idnext,nevents)
c       write(6,*) ' Looping over ',nevents,' events in 1st ntuple'
c       call hgiven(idnext,htitle,nvar,chtags,rlow,rhigh)
c
c ---   Book the combined entries ntuple :        
c       call hcdir('//HISTOS',' ')
c       call hldir(' ',' ')
c       call hbookn(305,htitle,nvar,' ',1024,chtags)
c
c ---   Read in all the events from the ntuples and pack
c ---   the combined entries ntuple :
c       call hcdir('//IN1',' ')
c       call hldir(' ',' ')
c       call hrin(idnext,999999,0)
c       call hnoent(idnext,nevents)
c       write(6,*) ' Looping over ',nevents,' events in 1st ntuple'
c       call hgnpar(idnext,'histomerge')
c       do i=1,nevents
c         call hgnf(idnext,i,var,ierror)
c         if (ierror.NE.0) write(6,*) ' ERROR reading event from ntuple'
c         call hcdir('//HISTOS',' ')
c         call hfn(305,var)
c         call hcdir('//IN1',' ')
c       enddo
c       call hcdir('//IN2',' ')
c       call hldir(' ',' ')
c       call hrin(idnext,999999,0)
c       call hnoent(idnext,nevents)
c       write(6,*) ' Looping over ',nevents,' events in 2nd ntuple'
c       call hgnpar(idnext,'histomerge')
c       do i=1,nevents
c         call hgnf(idnext,i,var,ierror)
c         if (ierror.NE.0) write(6,*) ' ERROR reading event from ntuple'
c         call hcdir('//HISTOS',' ')
c         call hfn(305,var)
c         call hcdir('//IN2',' ')
c       enddo
c
c       call hcdir('//HISTOS',' ')
c       call hldir(' ',' ')
c       call hrout(305,ICYCLE,' ')
c       if (ICYCLE.NE.1) then
c         write(6,*) 'ReadInOut : ICYCLE =',ICYCLE
c         write(6,*) 'Dupicated NTUPLE ID'
c       endif        
c       
c     enddo
c
c2002 continue
c     
c     call hrend('IN1')
c     close(30)
c     call hrend('IN2')
c     close(30)
      
      return
      end


c

