      subroutine qqb_wbb_g(p,msq)
************************************************************************
*     Author: R.K. Ellis                                               *
*     July, 1998.                                                      *
************************************************************************
c---Matrix element squared averaged over initial colors and spins
c     q(-p1)+qbar(-p2) -->  g*  + W +g(p7)
c                           |    |
c                           |    --> nu(p3)+e^+(p4)
c                           |
c                           ---> b(p5)+bb(p6)
c   positively charged W only
      implicit none 
#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/masses.F"
#include "mcfm/../src/Inc/qcdcouple.F"
#include "mcfm/../src/Inc/ewcouple.F"
#include "mcfm/../src/Inc/ckm.F"
#include "mcfm/../src/Inc/prods.F"
#include "mcfm/../src/Inc/hardscale.F"
      integer j,k
      double precision p(mxpart,4),msq(-nf:nf,-nf:nf),redmsq,fac
      double precision qqbWbbg,qbqWbbg,qgWbbq,gqWbbq,gqbWbbqb,qbgWbbqb


      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=0d0
      enddo
      enddo

      call spinoru(7,p,za,zb)

      if (
     .      (s(5,6) .lt. four*hscalesq) 
     . .or. (s(1,5)*s(2,5)/s(1,2) .lt. hscalesq) 
     . .or. (s(1,6)*s(2,6)/s(1,2) .lt. hscalesq) ) return

      fac=gsq**3*gw**4/4d0
      qqbWbbg =+redmsq(1,2,7,5,6,3,4,4)*fac*aveqq
      qbqWbbg =+redmsq(2,1,7,5,6,3,4,4)*fac*aveqq
      qgWbbq  =+redmsq(1,7,2,5,6,3,4,4)*fac*aveqg
      qbgWbbqb=+redmsq(7,1,2,5,6,3,4,4)*fac*aveqg
      gqWbbq  =+redmsq(2,7,1,5,6,3,4,4)*fac*aveqg
      gqbWbbqb=+redmsq(7,2,1,5,6,3,4,4)*fac*aveqg

      do j=-nf,nf
      do k=-nf,nf

      msq(j,k)=0d0

      if     ((j .gt. 0) .and. (k .lt. 0)) then
      msq(j,k)=Vsq(j,k)*qqbWbbg

      elseif ((j .lt. 0) .and. (k .gt. 0)) then
      msq(j,k)=Vsq(j,k)*qbqWbbg

      elseif ((j .gt. 0) .and. (k .eq. 0)) then
      msq(j,k)=Vsum(j)*qgWbbq 
      elseif ((j .lt. 0) .and. (k .eq. 0)) then
      msq(j,k)=Vsum(j)*qbgWbbqb

      elseif ((j .eq. 0) .and. (k .gt. 0)) then
      msq(j,k)=Vsum(k)*gqWbbq

      elseif ((j .eq. 0) .and. (k .lt. 0)) then
      msq(j,k)=Vsum(k)*gqbWbbqb
      endif

      enddo
      enddo

      return
      end


      double precision function redmsq(j1,j2,j3,j4,j5,j6,j7,jb)
      implicit none
c matrix element squared summed over colors and spins
#include "mcfm/../src/Inc/constants.F"
#include "mcfm/../src/Inc/masses.F"
#include "mcfm/../src/Inc/prods.F"
      integer j1,j2,j3,j4,j5,j6,j7,jb
      double complex qedipp,qedimm,qedimp,qedipm,ipp,imm,imp,ipm
      double complex qedfpp,qedfmm,qedfmp,qedfpm,fpp,fmm,fmp,fpm
      double complex qcdapp,qcdamm,qcdamp,qcdapm,app,amm,amp,apm
      double complex qcdbpp,qcdbmm,qcdbmp,qcdbpm,bpp,bmm,bmp,bpm
      double precision pm,mm,pp,mp,prop
c---calculate the W propagator
      prop=((s(j6,j7)-wmass**2)**2+(wmass*wwidth)**2)
      

      apm=qcdapm(j1,j2,j3,j4,j5,j6,j7,jb)
      bpm=qcdbpm(j1,j2,j3,j4,j5,j6,j7,jb)
      ipm=qedipm(j1,j2,j3,j4,j5,j6,j7,jb)
      fpm=qedfpm(j1,j2,j3,j4,j5,j6,j7,jb)

      pm=V*xn/eight*(abs(apm)**2+abs(bpm)**2)
     &+V/(eight*xn)*(abs(ipm)**2+abs(fpm)**2-two*(abs(ipm+fpm))**2)

      
      amm=qcdamm(j1,j2,j3,j4,j5,j6,j7,jb)
      bmm=qcdbmm(j1,j2,j3,j4,j5,j6,j7,jb)
      imm=qedimm(j1,j2,j3,j4,j5,j6,j7,jb)
      fmm=qedfmm(j1,j2,j3,j4,j5,j6,j7,jb)

      mm=V*xn/eight*(abs(amm)**2+abs(bmm)**2)
     &+V/(eight*xn)*(abs(imm)**2+abs(fmm)**2-two*(abs(imm+fmm))**2)

      amp=qcdamp(j1,j2,j3,j4,j5,j6,j7,jb)
      bmp=qcdbmp(j1,j2,j3,j4,j5,j6,j7,jb)
      imp=qedimp(j1,j2,j3,j4,j5,j6,j7,jb)
      fmp=qedfmp(j1,j2,j3,j4,j5,j6,j7,jb)

      mp=V*xn/eight*(abs(amp)**2+abs(bmp)**2)
     &+V/(eight*xn)*(abs(imp)**2+abs(fmp)**2-two*(abs(imp+fmp))**2)

      app=qcdapp(j1,j2,j3,j4,j5,j6,j7,jb)
      bpp=qcdbpp(j1,j2,j3,j4,j5,j6,j7,jb)
      ipp=qedipp(j1,j2,j3,j4,j5,j6,j7,jb)
      fpp=qedfpp(j1,j2,j3,j4,j5,j6,j7,jb)
c      write(6,*) 'app',app
c      write(6,*) 'bpp',bpp
c      write(6,*) 'ipp',ipp
c      write(6,*) 'fpp',fpp
c      pause
      pp=V*xn/eight*(abs(app)**2+abs(bpp)**2)
     &+V/(eight*xn)*(abs(ipp)**2+abs(fpp)**2-two*(abs(ipp+fpp))**2)

      redmsq=(pm+mm+pp+mp)/prop
      return
      end
